routes/web.php
<?php

use App\Http\Controllers\TeamController;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\PlayerController;
use App\Http\Controllers\HomeController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "web" middleware group. Make something great!
|
*/

Route::get('/', [HomeController::class, 'index'])->name('home.index');


Route::resource('teams', TeamController::class);
Route::resource('players', PlayerController::class);

app/Constants.php
<?php

namespace App;

interface Constants
{
    public const TEAMS_COLLECTION = 'teams';
    public const PLAYERS_COLLECTION = 'players';
}

app/Models/Player.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;

class Player extends Model
{
    use HasFactory;

       /**
     * The attributes that are mass assignable.
     *
     * @var array<int, string>
     */
    protected $fillable = [
        'name',
        'age',
        'number',
        'position',
        'team_id'
    ];

    public function team()
    {
        return $this->belongsTo(Team::class);
    }
}

app/Models/Team.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Team extends Model
{
    use HasFactory;

    /**
     * The attributes that are mass assignable.
     *
     * @var array<int, string>
     */
    protected $fillable = [
        'name',
    ];

    public function players()
    {
        return $this->hasMany(Player::class);
    }
}

app/Models/User.php
<?php

namespace App\Models;

// use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Sanctum\HasApiTokens;

class User extends Authenticatable
{
    use HasApiTokens, HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array<int, string>
     */
    protected $fillable = [
        'name',
        'email',
        'password',
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array<int, string>
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array<string, string>
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
        'password' => 'hashed',
    ];
}

app/Http/Controllers/API/PlayerController.php
<?php

namespace App\Http\Controllers\API;

use App\Models\Player;
use Illuminate\Http\JsonResponse;
use App\Services\ResponseService;
use App\Http\Controllers\Controller;

class PlayerController extends Controller
{
    public function __construct(
        private readonly ResponseService $responseService
    ) {
    }

    public function index(): JsonResponse
    {
        $players = Player::paginate(10);

        return $this->responseService->successResponse(data: $players, statusCode: 200);
    }

    public function show($id)
    {
        $player = Player::findOrFail($id);

        return $this->responseService->successResponse(data: $player, statusCode: 200);
    }
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Routing\Controller as BaseController;

class Controller extends BaseController
{
    use AuthorizesRequests, ValidatesRequests;
}

app/Http/Controllers/HomeController.php
<?php

namespace App\Http\Controllers;

use Illuminate\View\View;
use App\Models\Team;

class HomeController extends Controller
{
    public function index(): View
    {
        $teams = Team::all();
        return view('welcome', compact('teams'));
    }
}

app/Http/Controllers/PlayerController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\PlayerRequest;
use App\Models\Player;
use Illuminate\Http\Request;
use App\Models\Team;
use Illuminate\View\View;

class PlayerController extends Controller
{
    public function __construct(
        private readonly Player $player,
        private readonly Team $team,
    ) {
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create(Request $request)
    {
        $request->validate([
            'team_id' => 'required',
        ]);

        $team = $this->team->findOrFail($request->team_id);

        return view('players.create', compact('team'));
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(PlayerRequest $request)
    {

        $player = $this->player->create($request->all());
        $team = $this->team->findOrFail($request->team_id);
        $team->players()->save($player);

        return redirect()->route('teams.show', ['team' => $team]);
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(Player $player): View
    {
        return view('players.edit', compact('player'));
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(PlayerRequest $request, Player $player)
    {
        $player->update($request->all());

        return redirect()->route('teams.show', ['team' => $player->team_id]);
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Player $player)
    {
        $player->delete();

        return redirect()->route('teams.show', ['team' => $player->team_id]);
    }
}

app/Http/Controllers/TeamController.php
<?php

namespace App\Http\Controllers;

use App\Models\Team;
use Illuminate\View\View;
use App\Http\Requests\TeamRequest;
use App\Services\Firebase\Firestore\FirestoreService;


class TeamController extends Controller
{
    public function __construct(
        private readonly Team $team,
    ) {
    }
    public function show(Team $team)
    {
        $team->load('players');
        return view('teams.show', compact('team'));
    }

    public function create(): View
    {
        return view("teams.create");
    }

    public function store(TeamRequest $request): View
    {
        $team = $this->team->create($request->all());
        return view('teams.show', compact('team'));
    }
}

resources/views/players/create.blade.php
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Create a New Player</title>
    <style>
        body {
            display: flex;
            justify-content: center;
            align-items: center;
            height: 100vh;
            margin: 0;
            background-color: #220d3a;
        }

        form {
            background-color: #bfb7eb;
            padding: 20px;
            border-radius: 8px;
            box-shadow: 0 4px 8px rgba(0, 0, 0, 0.1);
            text-align: center;
        }

        label {
            display: block;
            margin-bottom: 10px;
        }

        input {
            width: 100%;
            padding: 10px;
            margin-bottom: 20px;
            box-sizing: border-box;
        }

        button {
            background-color: #451e71;
            color: #fff;
            padding: 10px 20px;
            border: none;
            border-radius: 4px;
            cursor: pointer;
        }

        button:hover {
            background-color: #973eff;
        }
    </style>
</head>

<body>

    <form method="post" action="{{ route('players.store') }}">
        @csrf
        <input type="hidden" name="team_id" value="{{ $team->id }}">
        <label for="name">Player Name:</label>
        <input type="text" id="name" name="name" placeholder="enter player name" required>
        <label for="age">Player Age:</label>
        <input type="text" id="age" name="age" placeholder="enter player age" required>
        <label for="age">Player Position:</label>
        <input type="text" id="position" name="position" placeholder="enter player position" required>
        <label for="age">Player Number:</label>
        <input type="text" id="number" name="number" placeholder="enter player number" required>
        <button type="submit">Create Player</button>
    </form>
</body>

</html>

resources/views/players/edit.blade.php
<!-- resources/views/players/edit.blade.php -->

<!DOCTYPE html>
<html lang="en">

<head>
    <style>
        body {
            display: flex;
            justify-content: center;
            align-items: center;
            height: 100vh;
            margin: 0;
            background-color: #220d3a;
        }

        form {
            background-color: #bfb7eb;
            padding: 20px;
            border-radius: 8px;
            box-shadow: 0 4px 8px rgba(0, 0, 0, 0.1);
            text-align: center;
        }

        label {
            display: block;
            margin-bottom: 10px;
        }

        input {
            width: 100%;
            padding: 10px;
            margin-bottom: 20px;
            box-sizing: border-box;
        }

        button {
            background-color: #451e71;
            color: #fff;
            padding: 10px 20px;
            border: none;
            border-radius: 4px;
            cursor: pointer;
        }

        button:hover {
            background-color: #973eff;
        }
    </style>
</head>

<body>
    <form method="post" action="{{ route('players.update', ['player' => $player->id]) }}">
        @csrf
        @method('PUT')


        <input type="hidden" name="team_id" value="{{ $player->team_id }}">
        <label for="name">Player Name:</label>
        <input type="text" id="name" name="name" value="{{ old('number', $player->name) }}" required>

        <label for="age">Player Age:</label>
        <input type="text" id="age" name="age" value="{{ old('number', $player->age) }}" required>

        <label for="age">Player Position:</label>
        <input type="text" id="position" name="position" value="{{ old('number', $player->position) }}" required>

        <label for="age">Player Number:</label>
        <input type="text" id="number" name="number" value="{{ old('number', $player->number) }}" required>

        <button type="submit">Update Player</button>

    </form>
</body>

</html>